#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <bitset>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, q;
    std::cin >> n >> q;
    std::vector<int> arr(n);
    for (int& elem : arr) {
        std::cin >> elem;
    }
    int ind = (9 * n + 9) / 10;
    int cntl1 = 0;
    int cntl2 = 0;
    for (int i = 0; i < ind; ++i) {
        if (arr[i] == 1) {
            ++cntl1;
        } else {
            ++cntl2;
        }
    }
    int cntr1 = 0;
    int cntr2 = 0;
    for (int i = ind; i < n; ++i) {
        if (arr[i] == 1) {
            ++cntr1;
        } else {
            ++cntr2;
        }
    }
    while (q--) {
        int t, x;
        std::cin >> t >> x;
        if (t == 1) {
            if (x == ind) {
                if (arr[x - 1] == 1) {
                    --cntl1;
                } else {
                    --cntl2;
                }
                if (arr[x] == 1) {
                    ++cntl1;
                } else {
                    ++cntl2;
                }
                if (arr[x] == 1) {
                    --cntr1;
                } else {
                    --cntr2;
                }
                if (arr[x - 1] == 1) {
                    ++cntr1;
                } else {
                    ++cntr2;
                }
            }
            std::swap(arr[x - 1], arr[x]);
        } else {
            if (arr[x - 1] == 1) {
                if (arr[0] == 1) {
                    if (cntl2 + cntr2 >= cntl1 - 1) {
                        std::cout << cntl1 * 2 - 1 << '\n';
                    } else {
                        std::cout << ind + cntr2 << '\n';
                    }
                } else {
                    if (cntl2 + cntr2 >= cntl1) {
                        std::cout << cntl1 * 2 << '\n';
                    } else {
                        std::cout << ind + cntr2 << '\n';
                    }
                }
            } else {
                if (arr[0] == 1) {
                    if (cntl2 <= cntl1 - 1) {
                        std::cout << cntl2 * 2 << '\n';
                    } else {
                        std::cout << ind << '\n';
                    }
                } else {
                    if (cntl2 <= cntl1 + 1) {
                        std::cout << cntl2 * 2 - 1 << '\n';
                    } else {
                        std::cout << ind << '\n';
                    }
                }
            }
        }
    }
    return 0;
}